#if !defined(AFX_GA_H__829E753F_0F7A_46A8_A24A_6E98CF665AD0__INCLUDED_)
#define AFX_GA_H__829E753F_0F7A_46A8_A24A_6E98CF665AD0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "edgenetwork.h"
#include "para.h"
#include "Gene.h"
#include "TimePara.h"

class GA{
private: 
	GAPARA* para;
	const NETWORK* network;
	std::vector<Gene> pop;
	TimePara timePara;
	int actual_gen;

	readPara(char* parafile);
public:
	GA();
	GA(char* parafile,const NETWORK* network);

	InitialPop();

	run();

	copyGene(Gene &g1, Gene &g2);
	mutate(Gene &g);
	crossover(Gene &g1,Gene &g2);

	saveCommunity(char* datafile,char* communityfile);
	

	
	~GA();
};

#endif
