#include"readgml.h"

ReadGml::ReadGml()
{
};
ReadGml::ReadGml(NETWORK* net,char* filename)
{
	if(!PathFileExists(filename)){
		printf("inputfile %s does not exist!",filename);
	}
	else{
		file.open(filename);
		
		printf("the input file has been opened\n");

		char line[100];
		int verNum=0;
		int edgeNum=0;
		EDGE* curE=NULL;

		while(file.getline(line,100,'\n')){

			char* ptr = strstr(line,"id");

			if(ptr!=NULL){
				
				verNum++;
			}
			else{

				ptr=strstr(line,"edge");//ϢȡϣΪnet->vertexesֵ

				if(net->vertexes==NULL && ptr!=NULL)
				{
					net->nvertexes=verNum;
					net->vertexes=(VERTEX*)malloc(verNum*sizeof(VERTEX));

					vDegree=(int *)malloc(verNum*sizeof(int)); //ڴÿڵĶȣ

					VERTEX* tempP=net->vertexes;

					for(int i=0;i<verNum;i++)
					{
						tempP->id=i;
						tempP->edge=NULL;
						tempP->degree=0;
						tempP->label=NULL; //Ŀǰlabel;
						tempP->RvertexId=NULL;

						tempP++;

						*(vDegree+i)=0;
					}

				}
				else;


				ptr=strstr(line,"source");

				if(ptr!=NULL){
					
					curE=(EDGE*)malloc(sizeof(EDGE));
						
					         
					curE->id=edgeNum;  //Ϊ򵫱߲ظ磻

					curE->weight=0;  //Ȩֵ
					curE->RedgeNum=0;
					curE->RedgeId=NULL;

					sscanf(ptr,"source %d",&(curE->source));
					*(vDegree+curE->source)+=1;

					edgeNum++;
				}

				ptr=strstr(line,"target");

				if(ptr!=NULL){

					if(curE==NULL){
						printf("inpufile reading error!");

					}else{
						sscanf(ptr,"target %d",&(curE->target));
						*(vDegree+curE->target)+=1;
					}

					edges.push_back(*curE);

					curE=NULL;

				}
			}
		}

		//Ϊnetĸȸֵ
		for(int k=0;k<net->nvertexes;k++){

			int tempD=*(vDegree+k);
			(net->vertexes+k)->degree=tempD;

			(net->vertexes+k)->edge=(EDGE*)malloc(tempD*sizeof(EDGE));

			
		}

		net->nedge=edgeNum;

		net->edges=(EDGE*)malloc(edgeNum*sizeof(EDGE));

		EDGE* tempEdge=net->edges;


		for(int q=0;q<net->nvertexes;q++){
			*(vDegree+q)=0;       //³ʼѭдѶı
		}


	//	int iterNum=0;

		//Ϊı߸ֵΪı߸ֵĹܣ
		for(std::vector<EDGE>::iterator it=edges.begin();it!=edges.end();it++)
		{
			int index=it->source;
			VERTEX* tempV=net->vertexes+index;

			if(it->source != tempV->id ){
				printf("source vertex of the edge is different from tempV\n");
			}
			else{
				EDGE* tempE=(tempV->edge)+*(vDegree+index);
				tempE->id=it->id;
				tempE->source=it->source;
				tempE->target=it->target;

				tempE->weight=0;
				tempE->RedgeId=NULL;
				tempE->RedgeNum=0;

				*(vDegree+index)+=1;
		
			}

			index=it->target;
			tempV=net->vertexes+index;
			if(it->target != tempV->id ){
				printf("target vertex of the edge is different from tempV\n");
			}
			else{
				EDGE* tempE=(tempV->edge)+*(vDegree+index);
				tempE->id=it->id;
				tempE->source=it->source;
				tempE->target=it->target;

				tempE->weight=0;
				tempE->RedgeId=NULL;
				tempE->RedgeNum=0;

				*(vDegree+index)+=1;
			}


			//Ϊı߸ֵ
			tempEdge->id=it->id;
			tempEdge->id=it->id;
			tempEdge->source=it->source;
			tempEdge->target=it->target;

			tempEdge->weight=0;
			tempEdge->RedgeId=NULL;
			tempEdge->RedgeNum=0;

			tempEdge++;
		}

		//Ϊб߼ٱϢ

		tempEdge=net->edges;

		for(int n=0;n<net->nedge;n++){

			VERTEX* sourceNode=(net->vertexes)+(tempEdge->source);
            VERTEX* targetNode=(net->vertexes)+(tempEdge->target);
			EDGE* iterEdge=NULL;

			tempEdge->RedgeNum=(sourceNode->degree+targetNode->degree)-2;

			tempEdge->RedgeId=(int*)malloc(sizeof(int)*(tempEdge->RedgeNum));

			int tempIndex=0;
			int* ep=tempEdge->RedgeId;

			iterEdge=sourceNode->edge;

			for(tempIndex=0;tempIndex<sourceNode->degree;tempIndex++){

				if(iterEdge->id!=tempEdge->id){
					*ep=iterEdge->id;

					ep++;

				}

				iterEdge++;

			}

			iterEdge=targetNode->edge;

			for(tempIndex=0;tempIndex<targetNode->degree;tempIndex++){

				if(iterEdge->id!=tempEdge->id){
					*ep=iterEdge->id;

					ep++;

				}

				iterEdge++;

			}

			tempEdge++;


		}
	}
	
};
ReadGml::test(NETWORK* net){

	output.open("result.txt");

	if(net==NULL){
		printf("ΪNULL\n");
	}
	else{
	//	printf("%d,%d\n",net->nvertexes,net->nedge);
		output<<","<<net->nvertexes<<","<<net->nedge<<endl;
		int n=0;
		while(n<net->nvertexes){
	//		printf("id %d,%d\t;",net->vertexes[n].id,net->vertexes[n].degree);
			output<<"㣬"<<net->vertexes[n].id<<","<<net->vertexes[n].degree<<endl;

			int i=0;
			while(i<net->vertexes[n].degree){
				output<<net->vertexes[n].edge[i].id;
				i++;
			}
			output<<endl;
			n++;
		}
		n=0;
	//	printf("\n");
		while(n<net->nedge){
			EDGE* temp_e=&(net->edges[n]);
            output<<""<<temp_e->id<<":	"<<temp_e->source<<","<<temp_e->target<<endl;
	//		printf("%d,%d,%d\n",temp_e->id,temp_e->source,temp_e->target);
			int j=0;
			while(j<net->edges[n].RedgeNum){
				output<<net->edges[n].RedgeId[j]<<",";
				j++;
			}
			output<<endl;
			n++;

		}
	}

	output.close();


}
