#include "time.h"
#include "math.h"
#include "stdlib.h"
#include "rand.h"

//initial seed
void inirand()
{
	srand((unsigned)time(0));
}

//random generate float [0,1]
double drand()
{
	return (double)((rand()%32768)/32767.0);
}

//random generate float [low, up]
double randfloat(double low, double up)
{
	return drand() * fabs(up-low) + low ;
}

//random generate int [low, up], include the bound
int randint(int low, int up)
{
	return low+(int)((up-low+1)*rand()/(RAND_MAX+1.0));
}