#include "readtxt.h"
#include <algorithm>

ReadTxt::ReadTxt(){
};

ReadTxt::ReadTxt(NETWORK* net,char* filename){

	if(!PathFileExists(filename)){
		printf("inputfile %s does not exist!",filename);
	}
	else{
		file.open(filename);

		char ch[100];
	int EdgeNum=0;

	while(file.getline(ch,100,'\n')!=NULL){

		EdgeNum++;

		char* p=strstr(ch,"\t");
		char first[10];
		char second[10];
		int i=0;
		int j=0;


		char* q=ch;
		while(p!=q){

			first[i]=*q;
			i++;
			q++;

		}

		first[i]='\0';

		q++;

		while(*q!='\0'){

			second[j]=*q;
			j++;
			q++;
		}
		second[j]='\0';
		
			
		EDGE* temp_e=(EDGE*)malloc(sizeof(EDGE));  //ȡϢԭֻһӦļ¼
		temp_e->id=EdgeNum-1;
		temp_e->source=atoi(first);
		temp_e->target=atoi(second);

		edges.push_back(*temp_e);

		int flag_1=0;
		int flag_2=0;

		for(std::vector<int>::iterator it=vertexes.begin();it!=vertexes.end();it++){
			if(*it==temp_e->source){
				flag_1=1;
			}
			else if(*it==temp_e->target){
				flag_2=1;
			}
			else;

			if(flag_1==1&&flag_2==1){
				break;
			}
		}

		if(flag_1!=1){
			vertexes.push_back(temp_e->source);
			
		}
		if(flag_2!=1){
			vertexes.push_back(temp_e->target);
		}

	}

    sort(vertexes.begin(),vertexes.end());

	//ʼϢ
	net->nedge=EdgeNum;
	net->nvertexes=vertexes.size();

	net->vertexes=(VERTEX*)malloc(sizeof(VERTEX)*net->nvertexes);

	//ҪߵID0ʼ
	for(int i=0;i<net->nvertexes;i++){

		net->vertexes[i].id=vertexes[i];  
		net->vertexes[i].label=NULL;
		net->vertexes[i].edge=NULL;
		net->vertexes[i].RvertexId=NULL;
		net->vertexes[i].degree=0;
	}
	for(std::vector<EDGE>::iterator it=edges.begin();it!=edges.end();it++){

		net->vertexes[it->source].degree++;
		net->vertexes[it->target].degree++;
	}

	for(i=0;i<net->nvertexes;i++){

		net->vertexes[i].edge=(EDGE*)malloc(sizeof(EDGE)*net->vertexes[i].degree);
		net->vertexes[i].RvertexId=(int *)malloc(sizeof(int)*net->vertexes[i].degree);
	}

	std::vector<int> flag;
	for(i=0;i<net->nvertexes;i++){
		flag.push_back(0);
	}

	//ΪedgeRvertexIdֵ
	for(it=edges.begin();it!=edges.end();it++){
		net->vertexes[it->source].edge[flag[it->source]].id=it->id;
		net->vertexes[it->source].edge[flag[it->source]].source=it->source;
		net->vertexes[it->source].edge[flag[it->source]].target=it->target;            //edgeϢδʼ

		net->vertexes[it->source].RvertexId[flag[it->source]]=it->target;

        flag[it->source]++;

		net->vertexes[it->target].edge[flag[it->target]].id=it->id;
		net->vertexes[it->target].edge[flag[it->target]].source=it->source;
		net->vertexes[it->target].edge[flag[it->target]].target=it->target;            //edgeϢδʼ

		net->vertexes[it->target].RvertexId[flag[it->target]]=it->source;

        flag[it->target]++;
	}

	//Ϊı߽гʼ
	net->edges=(EDGE*)malloc(sizeof(EDGE)*net->nedge);
	int k=0;
	for(it=edges.begin();it!=edges.end();it++){

		net->edges[k].id=it->id;
		net->edges[k].source=it->source;
		net->edges[k].target=it->target;
		net->edges[k].RedgeNum=net->vertexes[it->source].degree+net->vertexes[it->target].degree-2;
		net->edges[k].weight=0;
		net->edges[k].RedgeId=(int*)malloc(sizeof(int)*net->edges[k].RedgeNum);
		int flag=0;
		for(int j=0;j<net->vertexes[it->source].degree;j++){

			if(net->vertexes[it->source].edge[j].id!=it->id){
               net->edges[k].RedgeId[flag]=net->vertexes[it->source].edge[j].id;
			   flag++;
			}
		}
		for(j=0;j<net->vertexes[it->target].degree;j++){

			if(net->vertexes[it->target].edge[j].id!=it->id){
               net->edges[k].RedgeId[flag]=net->vertexes[it->target].edge[j].id;
			   flag++;
			}
		}

		k++;

	}

	//ڱߵϢ
	for(i=0;i<net->nvertexes;i++){

	}

	printf("finish reading txt\n");

	for(i=0;i<net->nedge;i++){
	//	printf("this is edge %d\n",net->edges[i].id);

	}
	}


}

ReadTxt::test(NETWORK* net){

	output.open("result.txt");

	if(net==NULL){
		printf("ΪNULL\n");
	}
	else{
	//	printf("%d,%d\n",net->nvertexes,net->nedge);
		output<<","<<net->nvertexes<<","<<net->nedge<<endl;
		int n=0;
		while(n<net->nvertexes){
	//		printf("id %d,%d\t;",net->vertexes[n].id,net->vertexes[n].degree);
			output<<"㣬"<<net->vertexes[n].id<<","<<net->vertexes[n].degree<<endl;

			int i=0;
			while(i<net->vertexes[n].degree){
				output<<net->vertexes[n].edge[i].id<<",";
				i++;
			}
			output<<endl;
			n++;
		}
		n=0;
	//	printf("\n");
		while(n<net->nedge){
			EDGE* temp_e=&(net->edges[n]);
            output<<""<<temp_e->id<<":	"<<temp_e->source<<","<<temp_e->target<<endl;
	//		printf("%d,%d,%d\n",temp_e->id,temp_e->source,temp_e->target);
			int j=0;
			while(j<net->edges[n].RedgeNum){
				output<<net->edges[n].RedgeId[j]<<",";
				j++;
			}
			output<<endl;
			n++;

		}
	}

	output.close();


}